part of mdlcomponents;

class MdlHeaderColumn {
	String label;
	bool nonnumeric;
	Map<String,bool> cssclass = {"mdl-data-table__cell--non-numeric":false}; 
	MdlHeaderColumn(String label, [bool nonnumeric = false]){
	this.label = label;
	this.nonnumeric = nonnumeric;
	this.cssclass["mdl-data-table__cell--non-numeric"] = nonnumeric;
	}
	
}

class MdlHeaderTable {
	Map<String,bool> cssheadercolor = new Map<String,bool>();
	List<MdlHeaderColumn> header;
	MdlHeaderTable(List<MdlHeaderColumn> header,[String headercolor = "mdl-color--cyan-100"]){
	this.header = header;
	print("header color: $headercolor");
	if (headercolor != null) {
		this.cssheadercolor[headercolor] = true;
		} else
		{
		this.cssheadercolor["mdl-color--cyan-100"] = true;
		}
	}
}

class MdlTableRow {
	List<dynamic> value;
	Map<String,bool> cssclass = {"mdl-data-table__cell--non-numeric":false};
	MdlTableRow(List<dynamic> this.value);
}

/// directive for materialtextfield
@Directive(
	selector: '[selectable]')
class TableSelectable{}

@Component(
	selector: 'mdl-table',
	directives: const [COMMON_DIRECTIVES,TableSelectable],
	templateUrl: 'src/components/MdlTable.html')

class MdlTable {
	ApplicationRef _appRef;
	bool _selectable;
	String _id;
	Map<String,bool> _tablecssClasses;
	Map<String,bool> _rowcssClasses;
	
	MdlHeaderTable _header;
	List<MdlTableRow> _rows;
	
    MdlTable(@Optional() @Attribute('selectable') String selectable,ApplicationRef appRef){
     _appRef = appRef;
     List<Mdlheafercolumn> _c = [new MdlHeaderColumn('Name'),new MdlHeaderColumn('Value')];
     _rows = [new MdlTableRow(['Peter',22]),new MdlTableRow(['Bob',47])];
     _header = new MdlHeaderTable(_c);
     if (selectable != null && selectable.isEmpty) { _selectable = true;}
    Uuid uuid = new Uuid();
    _id = uuid.v1();
	}

	bool get selectable => _selectable;
	
	MdlHeaderTable get header => _header;
	
	MdlTableRow get rows => _rows;

	void set header(value){
	if (value != null){
		_header = value;
		}
	}

	void set data(value){
	if (value != null){
		_rows = value;
		}
	}

	void tick(){
	 _appRef.tick();
	}
}

